
function vid_mate_get_video_id() {
	var vid_mate_url = window.location.pathname;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	if (document.location.hostname != 'www.ndtv.com' && document.location.hostname != 'm.ndtv.com') {
		return null;
	}
	var tmp_re = new RegExp('/video/player/([^/]+)/([^/]+)/([0-9]+)(.*)');
	if (!tmp_re.test(vid_mate_url)) {
		return null;
	}
	var tmp_m = vid_mate_url.match(tmp_re);
	return tmp_m[3];
}

function vid_mate_check() {
    if (vid_mate_get_video_id() == null) {
        vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_video_analytics(vm_content) {
    vid_mate_setParseMsg(60, 90, 'Analytics Video Info');

    var rtn_video = new vid_mate_video();
    rtn_video.check_type = "ndtv";
    var tmp_video_file = new vid_mate_video_file();
    rtn_video.id = vid_mate_get_video_id();
    var content = vm_content;
    if (document.location.hostname == 'www.ndtv.com') {
        var tmp_re = new RegExp('<meta property="og:title" content="([^"]+)"/>');
        if (tmp_re.test(content)) {
            var tmp_m = content.match(tmp_re);
            rtn_video.title = tmp_m[1];
        } else {
            vid_mate_error_default('ndtv 1');
            return null;
        }
        var tmp_re = new RegExp('<meta property="og:image" content="([^"]+)"/>');
        if (tmp_re.test(content)) {
            var tmp_m = content.match(tmp_re);
            rtn_video.picture_default = tmp_m[1];
            rtn_video.picture_big = tmp_m[1];
        } else {
            rtn_video.picture_default = '';
            rtn_video.picture_big = '';
        }
    } else {
        var tmp_metas = document.getElementsByTagName('meta');
        for (var i = 0; i < tmp_metas.length; i++) {
            var tmp_property = tmp_metas[i].getAttribute('property');
            var tmp_content = tmp_metas[i].getAttribute('content');
            if (tmp_property == 'og:title') {
                rtn_video.title = tmp_content;
            } else if (tmp_property == 'og:image') {
                rtn_video.picture_default = tmp_content;
                rtn_video.picture_big = tmp_content;
            }
        }
        if (rtn_video.title.length <= 0) {
            vid_mate_error_default('ndtv 2');
            return null;
        }
        content = document.body.innerHTML;
    }

    if (content.indexOf('<span class="vod_dateline">Published On:') > 0) {
        var tmp_content = content.substring(content.indexOf('<span class="vod_dateline">Published On:') + '<span class="vod_dateline">Published On:'.length);
        if (tmp_content.indexOf('<span>') > 0) {
            tmp_content = tmp_content.substring(tmp_content.indexOf('<span>') + 6);
        }
        if (tmp_content.indexOf('</span>') > 0) {
            tmp_content = tmp_content.substring(0, tmp_content.indexOf('</span>'));
        }
        var tmp_re = new RegExp('Duration: (([0-9]+) hr, )?([0-9]+) min, ([0-9]+) sec');
        if (tmp_re.test(tmp_content)) {
            var tmp_m = tmp_content.match(tmp_re);
            var tmp_hour = 0;
            if (tmp_m[2] != null) {
                tmp_hour = tmp_m[2];
            }
            var tmp_min = tmp_m[3];
            var tmp_sec = tmp_m[4];
            rtn_video.duration = Number(tmp_hour) * 3600 + Number(tmp_min) * 60 + Number(tmp_sec);
        } else {
            rtn_video.duration = 0;
        }
    } else {
        rtn_video.duration = 0;
    }
    rtn_video.url = document.URL;
    tmp_video_file.width = 0;
    tmp_video_file.height = 0;
    tmp_video_file.f_id = rtn_video.id + '_0_0';
    tmp_video_file.length = 0;
    tmp_video_file.quality = '';
    var tmp_re = new RegExp("<source src=\"'\\+([^\\+]+)\\+'\" type=\"video/mp4\">");
    if (tmp_re.test(content)) {
        var tmp_m = content.match(tmp_re);
        var tmp_param = tmp_m[1];
        var tmp_re = new RegExp("var " + tmp_param + " = ([^\\+]+)\\+([^;]+);");
        if (tmp_re.test(content)) {
            var tmp_m = content.match(tmp_re);
            var tmp_param1 = tmp_m[1];
            var tmp_param2 = tmp_m[2];
            var tmp_re = new RegExp("var " + tmp_param2 + " = '([^']+)';");
            if (tmp_re.test(content)) {
                var tmp_m = content.match(tmp_re);
                var tmp_filename = tmp_m[1];
                var tmp_re = new RegExp("var " + tmp_param1 + " = '([^']+)';");
                if (tmp_re.test(content)) {
                    var tmp_m = content.match(tmp_re);
                    var tmp_url = tmp_m[1];
                    tmp_video_file.url = decodeURIComponent(tmp_url) + decodeURIComponent(tmp_filename);
                } else {
                    vid_mate_error_default('ndtv 3');
                    return null;
                }
            } else {
                vid_mate_error_default('ndtv 4');
                return null;
            }
        } else {
            vid_mate_error_default('ndtv 5');
            return null;
        }
    } else {
        vid_mate_error_default('ndtv 6');
        return null;
    }
    var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
    tmp_video_file.format = tmp_format;
    tmp_video_file.title = tmp_format;
    rtn_video.files.push(tmp_video_file);
    vid_mate_setParseMsg(100, 100, 'Completed');
    vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info() {
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	if (!vid_mate_check()) {
		return null;
	}

	var vid_mate_video_id = vid_mate_get_video_id();

	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	if (document.location.hostname == 'www.ndtv.com') {
		var vid_mate_url = 'http://m.ndtv.com' + document.location.pathname;

		try {
			vid_mate_app_xhr(vid_mate_url);
		} catch (e) {
			vid_mate_error_default('ndtv 7\r\n' + e.name + ': ' + e.message);
			return null;
		}
	} else if (document.location.hostname == 'm.ndtv.com') {
	    vid_mate_video_analytics(vid_mate_video_id);
	} else {
		return null;
	}
}

